/*
 * KyuurekiNode.java
 *
 * Created on 2008/01/26, 8:01
 *
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.kyuureki;

/**
 * KyuurekiAlmanacクラスが、グレゴリオ暦→旧暦変換に使うデータをこのオブジェクト
 * に入れて管理する。
 * @author 大澤義鷹
 */
class KyuurekiNode extends KyuurekiDate {
    protected double jday;
    private KyuurekiNode() { }

    /**  
     * KyuurekiNode オブジェクトを作成する 
     */
    protected KyuurekiNode(  boolean leap, int month, int day, double jday ) {
        super(leap,month,day);
        this.jday = jday;
    }
    /**
     * このオブジェクトの文字列表現を返す。KyuurekiDate#toString()の末尾に
     * ", jday = xxxxxxxx.xxxx"とユリウス日時刻が追加されている。
     */
    public String toString() {
        return super.toString() + ",jday = " + jday;
    }
}
