/*
 * KansiKyuuseiTest.java
 * JUnit based test
 *
 * Created on 2008/02/20, 18:07
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.kyuureki;

import junit.framework.*;
import java.util.Calendar;
import java.util.GregorianCalendar;

/**
 *
 * @author 大澤義鷹
 */
public class KansiKyuuseiTest extends TestCase {
    
    public KansiKyuuseiTest(String testName) {
        super(testName);
    }

    String kansi(int year,int month,int day,int hh,int mm) {
        GregorianCalendar cal = new GregorianCalendar(year,month-1,day,hh,mm,0);
        cal.set(Calendar.MILLISECOND,0);
        Kansi kansi = new Kansi();
        KansiKyuuseiAlmanac.getValue(cal,kansi);
        String ky = kansi.get干支( Kansi.YEAR );
        String km = kansi.get干支( Kansi.MONTH );
        String kd = kansi.get干支( Kansi.DAY );
        String kt = kansi.get干支( Kansi.HOUR );
        String sy = kansi.get九星略称( Kansi.YEAR );
        String sm = kansi.get九星略称( Kansi.MONTH );
        String sd = kansi.get九星略称( Kansi.DAY  );
        String st = kansi.get九星略称( Kansi.HOUR );
        
        String s =  String.format("%s %s %s %s %s %s %s %s",ky,km,kd,kt,sy,sm,sd,st);
        System.out.println(s);
        return s;
    }
    protected void setUp() throws Exception {
    }

    protected void tearDown() throws Exception {
    }

    /**
     * 年月日時の干支が正しく求まるかテスト
     */
    public void testKansi() {
        assertEquals( kansi(1987,  2,  4, 17, 51), "丙寅 辛丑 甲申 癸酉 五黄 九紫 三碧 七赤" );
        assertEquals( kansi(1913,  2,  4, 10, 35), "壬子 癸丑 丙辰 癸巳 七赤 六白 八白 九紫" );
        assertEquals( kansi(1963,  5, 10, 23, 30), "癸卯 丁巳 甲寅 甲子 一白 五黄 三碧 七赤" );
        assertEquals( kansi(1987,  9, 28,  9, 15), "丁卯 己酉 庚辰 辛巳 四緑 一白 五黄 一白" );
        assertEquals( kansi(1964,  9, 30,  5, 35), "甲辰 癸酉 壬午 癸卯 九紫 七赤 三碧 六白" );
        assertEquals( kansi(1926,  2,  7, 12,  0), "丙寅 庚寅 丁卯 丙午 二黒 二黒 一白 七赤" );
        assertEquals( kansi(1744,  5, 28, 12,  0), "甲子 己巳 甲子 庚午 四緑 五黄 九紫 三碧" );
        assertEquals( kansi(1905, 11, 21, 12,  0), "乙巳 丁亥 甲子 庚午 五黄 二黒 九紫 三碧" );
        assertEquals( kansi(1916, 11, 23, 12,  0), "丙辰 己亥 甲子 庚午 三碧 五黄 九紫 三碧" );
        //fail("The test case is a prototype.");
    }

    
}
