/*
 * DateRectangle.java
 *
 * Created on 2008/02/13, 6:37
 *
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.michiteru;

import java.awt.Rectangle;
import java.util.Calendar;

/**
 * カレンダーの日にちセルの、当たり判定用。
 * @author 大澤義孝
 */
class DateRectangle extends Rectangle {
    Calendar dateCal;
    /**
     * DateRectangle オブジェクトを作成する。
     * Rectangleと同じだが、最後にカレンダーフィールドが追加されている。
     */
    public DateRectangle( int x, int y,int width, int height, Calendar cal ) {
        super( x, y, width, height);
        this.dateCal = cal;
    }
    @Override
    public String toString() {
        String s = "時刻未登録";
        if ( dateCal != null ) s = String.format("%tF %tT",dateCal,dateCal);
        return s + " " + super.toString();
    }
}
