/*
 * PlanetActionListener.java
 *
 * Created on 2007/05/05, 4:30
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase.chartparts;

import to.tetramorph.starbase.lib.Body;

/**
 * ホロスコープ上の天体のイベントリスナインターフェイス。
 * @author 大澤義鷹
 */
public interface PlanetActionListener {
  /**
   * PlanetRing内の天体がクリックされたことを知らせる。
   */
  public void bodyClicked(PlanetEvent evt);
  /**
   * PlanetRing内の天体がダブルクリックされたことを知らせる。
   */
  public void bodyDoubleClicked(PlanetEvent evt);
  /**
   * PlanetRing内の天体にオンカーソルしたことを知らせる。
   */
  public void bodyOnCursor(PlanetEvent evt);
  /**
   * PlanetRing内の天体からアウトカーソルしたことを知らせる。
   */
  public void bodyOutCursor(PlanetEvent evt);
  
//  /**
//   * PlanetRing内の天体がドラッグで移動されたことを知らせる。
//   */
//  public void bodyDragged(PlanetEvent evt);

}
