/*
 * SignDialFrame.java
 *
 * Created on 2007/10/24, 8:03
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase.chartparts;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.RenderingHints;
import javax.swing.JPanel;
/**
 * サインダイアルの描画速度を計測するテスト。
 * @author  大澤義鷹
 */
public class SignDialFrame extends javax.swing.JFrame {
  SignDial signDial = new SignDial();
  BasePosition bp = new BasePosition();
  GraphicsPanel gp;
  double roll = 0;
  /** Creates new form SignDialFrame */
  public SignDialFrame() {
    initComponents();
    gp = new GraphicsPanel();
    add(gp,BorderLayout.CENTER);
    setPreferredSize(new Dimension(400,400));
    signDial.setSymbolSize(0.05f);
    signDial.setDiameter(0.8);
    signDial.setBasePosition(bp);
    pack();
    this.setLocationRelativeTo(null);
  }
  class GraphicsPanel extends JPanel {
    public void paintComponent(Graphics graphics) {
      super.paintComponents(graphics);
      Graphics2D g = (Graphics2D)graphics;
      g.setRenderingHint( RenderingHints.KEY_ANTIALIASING,
        RenderingHints.VALUE_ANTIALIAS_ON);
      Rectangle size = getBounds();
      double width = (float)size.getWidth();
      double height = (float)size.getHeight();
      g.setPaint(Color.WHITE);
      g.fillRect(size.x,size.y,size.width,size.height);
      bp.x = width / 2d;
      bp.y = height / 2d;
      bp.w = width < height ? width : height;
      bp.g = g;
      long t = System.currentTimeMillis();
      signDial.draw();
      System.out.printf("%d [ms]\n",System.currentTimeMillis() - t);
    }
  }
    
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc=" Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {
    jPanel1 = new javax.swing.JPanel();
    jButton1 = new javax.swing.JButton();
    jButton2 = new javax.swing.JButton();

    setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
    jButton1.setText("\u30ea\u30da\u30a4\u30f3\u30c8");
    jButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton1ActionPerformed(evt);
      }
    });

    jPanel1.add(jButton1);

    jButton2.setText("\u56de\u8ee2");
    jButton2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton2ActionPerformed(evt);
      }
    });

    jPanel1.add(jButton2);

    getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

    pack();
  }// </editor-fold>//GEN-END:initComponents

  private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
    roll+=5;
    signDial.setRoll(roll);
    gp.repaint();
  }//GEN-LAST:event_jButton2ActionPerformed

  private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
    gp.repaint();
  }//GEN-LAST:event_jButton1ActionPerformed
  
  /**
   * @param args the command line arguments
   */
  public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {
      public void run() {
        new SignDialFrame().setVisible(true);
      }
    });
  }
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton jButton1;
  private javax.swing.JButton jButton2;
  private javax.swing.JPanel jPanel1;
  // End of variables declaration//GEN-END:variables
  
}
