/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase.dict;

import javax.swing.tree.DefaultTreeModel;


/**
 * ツリーノードの「削除」命令。
 * @author 大澤義鷹
 */
class DeleteCommand implements ShellCommand {
    DefaultTreeModel model;
    DictNode removeNode;
    DictNode parentNode;
    int index;
    DictTree tree;
    public DeleteCommand( DictTree tree, DictNode removeNode ) {
        this.tree = tree;
        this.model = (DefaultTreeModel)tree.getModel();
        this.removeNode = removeNode;
        //削除するノードの親を求める
        parentNode = (DictNode)removeNode.getParent();
        //削除ノードが親の子配列の何番目にあるかを知る
        index = parentNode.getIndex( removeNode );
    }
    @Override
    public void redo() {
        model.removeNodeFromParent( removeNode );
        if ( parentNode.isRoot() ) {
            //本が丸ごと削除された場合は本の管理ファイルを更新
            Librarian.getInstance().updateIndexes();
        }
    }

    @Override
    public void undo() {
        model.insertNodeInto(removeNode, parentNode, index);
        tree.expandPath(parentNode.getTreePath());
        if ( parentNode.isRoot() ) {
            Librarian.getInstance().updateIndexes();
        }
    }

}
