/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase.dict;

import javax.swing.tree.DefaultTreeModel;

/**
 * ツリーノードの「リネーム」命令。
 * @author 大澤義鷹
 */
class RenameCommand implements ShellCommand {
    DefaultTreeModel model;
    DictNode renamedNode;
    String newName;
    String oldName;
    DictTree tree;
    public RenameCommand( DictTree tree, DictNode renamedNode, String oldName ) {
        this.tree = tree;
        this.model = (DefaultTreeModel)tree.getModel();
        this.renamedNode = renamedNode;
        this.newName = renamedNode.toString();
        this.oldName = oldName;
        System.out.println("renamedNode = " + renamedNode + ", oldName = " + oldName);
    }

    @Override
    public void redo() {
        renamedNode.setUserObject(newName);
        model.nodeChanged(renamedNode);
    }

    @Override
    public void undo() {
        renamedNode.setUserObject(oldName);
        model.nodeChanged(renamedNode);
        tree.expandPath(renamedNode.getTreePath());
    }

}
