/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

/*
 * TestFrame.java
 *
 * Created on 2008/12/10, 23:01:48
 */

package to.tetramorph.starbase.dict;

import java.io.File;
import to.tetramorph.starbase.util.Dictionary;
import javax.swing.UIManager;


/**
 * DictionaryDialogの動作テスト。
 * java -jar dict.jarとして起動したときのエントリークラス。
 * @author 大澤義鷹
 */
class TestFrame extends javax.swing.JFrame {

    static Dictionary bookEditor;

    public TestFrame() {
        initComponents();
        pack();
        this.setLocationRelativeTo(null);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jButton1 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("DictionaryDialogTest");
        getContentPane().setLayout(new java.awt.FlowLayout());

        jButton1.setText("Open");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        getContentPane().add(jButton1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        bookEditor.setVisible(true);
    }//GEN-LAST:event_jButton1ActionPerformed
    //ニンバスLaFを使うときは、main()内からこれを呼び出す。
    private static void nimbus() {
        try {
            UIManager.setLookAndFeel(
                    "com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    /**
     * アマテルとは切り離して、辞書を単体で動作させる時のエントリー。
     * （デバッグ用の機能）<br>
     * >java [ -Dapp.home="\Documents and Settings\ユーザ名\.Amateru"] -jar dict.jar<br>
     * などとする。<br>
     * -Dオプションで、プロパティ"app.home"の指定を省略したときは、
     * "user.home + 'amateru_test'"をアプリケーションのホームディレクトリと見なし
     * て実行する。このディレクトリの下の./dict内に、std_dict.abfファイルが無いと、
     * 標準辞書を開く動作でエラーが出る。それを気にしないのであれば、app.homeの
     * 指定は無くても良い。<br>
     * <br>
     * NetBeans上で実行する場合、プロジェクトのプロパティ→実行→VMオプションの項目に
     * "-Dapp.home=C:\Users\ohsawa\.Amateru"などと指定する。その下にあるdistを自動
     * 検出する。
     * @param args 引数は無視される。
     */
    public static void main(String args[]) {
        System.out.println("アマテル辞書（単体動作モード）");
        if (System.getProperty("app.home") == null) {
            File file = new File(System.getProperty("user.home"), "amateru_test");
            System.setProperty("app.home", file.getAbsolutePath());
            System.out.println("app.home = \""
                    + System.getProperty("app.home") + "\"");
            System.out.println(
                    "明示的に\"app.home\"プロパティを指定するには、\n\n"
                    + ">java -Dapp.home=\"Documents and Settings\\<ユーザ名>"
                    + "\\.Amateru\" -jar dict.jar\n\n"
                    + "などとします。");
        } else {
            File file = new File(System.getProperty("app.home"));
            System.out.println("app.home = \""
                    + System.getProperty("app.home") + "\"");
            if (!file.isDirectory()) {
                System.out.println(
                        "\"app.home\"で指定されたフォルダは存在しません。");
                System.exit(0);
            }
        }
        java.awt.EventQueue.invokeLater(new Runnable() {

            @Override
            public void run() {
                //nimbus();
                UIManager.put("swing.boldMetal", Boolean.FALSE);
                TestFrame frame = new TestFrame();
                bookEditor = DictionaryDialog.createInstance(frame, null);
                frame.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    // End of variables declaration//GEN-END:variables

}
