package to.tetramorph.starbase.dict;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.IOException;

/**
 * DnDのときにドラッグされるオブジェクトを格納するクラス
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */
class TransferableNodes implements Transferable {

    Object object;
    DictTree tree;

    public TransferableNodes(Object o, DictTree tree) {
        super();
        this.tree = tree;
        object = o;
    }

    public Object getTransferData(DataFlavor df)
            throws UnsupportedFlavorException, IOException {
        if (isDataFlavorSupported(df)) {
            return object;
        } else {
            throw new UnsupportedFlavorException(df);
        }
    }

    public boolean isDataFlavorSupported(DataFlavor df) {
        return df.equals( tree.getDataFlavor() );
    }

    public DataFlavor[] getTransferDataFlavors() {
        return tree.getSupportedFlavors();
    }
}
