/*
 *
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */
package to.tetramorph.starbase.formatter;
import javax.swing.*;
import java.text.ParseException;
import java.util.*;
/**
 * テキストフィールドに入力されたタイムゾーンIDをフォーマットする。
 * タイムゾーンIDというのは、java.util.TimeZoneで指定するIDのこと。
 * メソッドの動作についはGregorianDateFormatterを見よ。原理は同じ。
 * @see GregorianDateFormatter
 * @see java.util.TimeZone
 */
public class TimeZoneFormatter extends AbstractFormatter {
    TimeZone z = TimeZone.getDefault();
    /**
     * @param zoneid TimeZone IDを与える。
     */
    public Object stringToValue(String zoneid) 
                                             throws IllegalArgumentException {
        if(zoneid == null) return null;
        z = TimeZone.getTimeZone(zoneid);
        return z;
    }
    /**
     * @param value TimeZoneオブジェクトを与える
     */
    public String valueToString(Object value)
                                             throws IllegalArgumentException {
        if(value == null) return null;
        return ((TimeZone)value).getID();
    }
}
