/*
 * TopoTestFrame.java
 *
 * Created on 2008/01/05, 11:17
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase.formatter;

/**
 * TopoFormatterのテスト。
 * @author  大澤義鷹
 */
public class TopoTestFrame extends javax.swing.JFrame {
    static final String TOPO_UNIT = "app.topounit";
    /** Creates new form TopoTestFrame */
    public TopoTestFrame() {
        initComponents();
        lonFTextField.setFormatterFactory(new FormatterFactory(
            new TopoFormatter(TopoFormatter.LONGITUDE)));
        lonFTextField.setDocument(new LimitedDocument(12));
        latFTextField.setFormatterFactory(new FormatterFactory(
            new TopoFormatter(TopoFormatter.LATITUDE,lonFTextField)));
        latFTextField.setDocument(new LimitedDocument(12+13));
    }
    /**
     * 10進/60進を切り替えたとき、フィールドの表示もそれに合わせて更新するために
     * は、現在の値を再セットしてやれば良いらしい。update,updateUI,validate,
     * revalidate,paintなどは効力を持たない。
     *
     */
    private void test() {
        lonFTextField.setValue( lonFTextField.getValue() );
        latFTextField.setValue( latFTextField.getValue() );
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        lonFTextField = new javax.swing.JFormattedTextField();
        jLabel2 = new javax.swing.JLabel();
        latFTextField = new javax.swing.JFormattedTextField();
        jPanel2 = new javax.swing.JPanel();
        sexagesimalButton = new javax.swing.JButton();
        dicimalButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        jPanel1.setLayout(new java.awt.GridBagLayout());

        jLabel1.setText("\u7def\u5ea6");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        jPanel1.add(jLabel1, gridBagConstraints);

        lonFTextField.setColumns(12);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        jPanel1.add(lonFTextField, gridBagConstraints);

        jLabel2.setText("\u7d4c\u5ea6");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        jPanel1.add(jLabel2, gridBagConstraints);

        latFTextField.setColumns(12);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        jPanel1.add(latFTextField, gridBagConstraints);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        sexagesimalButton.setText("60\u9032\u6570");
        sexagesimalButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sexagesimalButtonActionPerformed(evt);
            }
        });

        jPanel2.add(sexagesimalButton);

        dicimalButton.setText("10\u9032\u6570");
        dicimalButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                dicimalButtonActionPerformed(evt);
            }
        });

        jPanel2.add(dicimalButton);

        getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void sexagesimalButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sexagesimalButtonActionPerformed
        System.setProperty( TOPO_UNIT,"60");
        test();
    }//GEN-LAST:event_sexagesimalButtonActionPerformed

    private void dicimalButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_dicimalButtonActionPerformed
        System.setProperty( TOPO_UNIT,"10");
        test();
    }//GEN-LAST:event_dicimalButtonActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new TopoTestFrame().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton dicimalButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JFormattedTextField latFTextField;
    private javax.swing.JFormattedTextField lonFTextField;
    private javax.swing.JButton sexagesimalButton;
    // End of variables declaration//GEN-END:variables
    
}
