/*
 * AspectType.java
 *
 * Created on 2006/08/16, 22:26
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase.lib;

import to.tetramorph.starbase.*;

/**
 * アスペクトの種類を表現するクラス
 */
public class AspectType {
  /** アスペクトID */
  public int aid;
  /** タイトオーブの角度 */
  public double tightOrb;
  /** ルーズオーブの角度 */
  public double looseOrb;
  /**
   * aidにアスペクト番号、tightOrbにタイトオーブの角度、looseOrbにルーズオーブの
   * 角度を指定する。
   * @param aid アスペクト種別番号
   * @param tightOrb タイトオーブの許容角度
   * @param looseOrb ルーズオーブの許容角度
   */
  public AspectType(int aid,double tightOrb,double looseOrb) {
    this.aid = aid;
    this.tightOrb = tightOrb;
    this.looseOrb = looseOrb;
  }
  /**
   * このオブジェクトの文字列表現を返す。
   */
  public String toString() {
    return "aid="+aid+",tightOrb="+tightOrb+",looseOrb="+looseOrb;
  }
}
