/*
 * ChannelData.java
 *
 * Created on 2006/11/27, 21:47
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase.lib;

import java.util.ArrayList;
import java.util.List;

/**
 * ChartDataを複数ラップして保管するクラスで、ChartModuleへ受け渡されるデータは、
 * この中にしまわれている。
 */
public class ChannelData implements java.io.Serializable {
    protected List<ChartData> list = new ArrayList<ChartData>();
    protected Transit transit;
    private TransitTabReceiver transitTabReceiver;
    
    /**
     * 中身が空のオブジェクトを作成
     */
    public ChannelData( TransitTabReceiver tr ) {
        transitTabReceiver = tr;
    }
    
    /**
     * ChartDataを登録する。
     */
    public void add( ChartData data ) {
        list.add(data);
    }
    
    /**
     * チャンネル数を返す
     */
    public int size() {
        return list.size();
    }
    
    /**
     * 指定番号のチャンネルに登録されているChartDataを返す。
     */
    public ChartData get( int num ) {
        return list.get( num );
    }
    
    /**
     * トランジットの日時場所を返す。
     */
    public Transit getTransit() {
        return transit;
    }
    
    /**
     * トランジットの日時場所をセットする。
     */
    public void setTransit( Transit transit ) {
        this.transit = transit;
    }

    /**
     * トランジットの日時をチャートモジュール側から更新するときに使用する。
     * トランジットタブに更新された日付が反映される。
     */
    public void updateTransit( Transit transit ) {
        transitTabReceiver.updateTransit( transit );
    }
}
