/*
 * TransitTabReceiver.java
 *
 * Created on 2007/07/18, 17:55
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase.lib;

/**
 * TimePanelをChannelDataに引き渡す際、TransitTabReceiverとして引き渡す。
 * なぜかというと、TimePanelはチャートモジュールからは直接はアクセスできないように
 * 保護されたクラスだから。しかしTimePanel内のトランジットタブにモジュール側の
 * 天体ドラッグ操作などで変更された日時を反映させる必要性があり、ChannelDataに
 * その機能を持たせたかった。そこでこのインターフェイスを実装することで、
 * TimePanelをChannelDataのコンストラクタで渡し、ChannelDataから更新されたTransit
 * をTimePanelに送る仕組みにしている。
 * @author 大澤義鷹
 */
public interface TransitTabReceiver {
  public void updateTransit(Transit transit);
}
