/*
 * ChartModuleMode.java
 *
 * Created on 2008/09/27, 22:07
 *
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase.module;

/**
 * チャートモジュールのモードを指定するために使用するクラス。
 * 一つのチャートモジュールで、複数の図を提供するような場合、モジュール起動の
 * 際に、どの図を描画するモードか初期設定を与えなければならないときがある。
 * たとえばNPT三重円モジュールは、一つのモジュールでネイタル1重円からNPT三重円
 * まで7種類の図版をカバーするが、最初にこのモジュールでチャートを表示するとき、
 * 7種類のうちどれを使うか指定したいときがある。そのときこのクラスを使う。
 * @author 大澤義孝
 */
public class ChartModuleMode {
    private String title;
    private String command;
    /**  ChartModuleMode オブジェクトを作成する */
    public ChartModuleMode( String title, String command ) {
        this.title = title;
        this.command = command;
    }

    public String getTitle() {
        return title;
    }

    public String getCommand() {
        return command;
    }
    public String toString() {
        return "title=" + title + ",command=" + command;
    }
}
