/*
 * LineStylePanel.java
 *
 * Created on 2007/01/01, 7:39
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase.widget;

import java.awt.BasicStroke;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Stroke;
import java.awt.geom.Line2D;

/**
 * アスペクト線種の設定で使用するラインスタイルを表示するためのパネル。
 * @author  大澤義鷹
 */
public class LineStylePanel extends javax.swing.JPanel {
    private Stroke stroke = new BasicStroke(1f);

    /** Creates new form LineStylePanel */
    public LineStylePanel() {
        initComponents();
    }

    /**
     * ラインスタイルをセットする
     */
    public void setStroke(Stroke stroke) {
        this.stroke = stroke;
        repaint();
    }

    /**
     * このオブジェクトのラインスタイルを返す。
     */
    public Stroke getStroke() {
        return stroke;
    }

    /**
     * プログラマはこのメソッドを呼び出す必要はありません。
     */
    @Override
    public void paintComponent(Graphics graphics) {
        super.paintComponent(graphics);
        Graphics2D g = (Graphics2D) graphics;
        Dimension size = getSize();
        double width = (float) size.getWidth();
        double height = (float) size.getHeight();
        Line2D line = new Line2D.Double(3, height / 2, width - 1, height / 2);
        g.setStroke(stroke);
        g.draw(line);
    }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        setLayout(null);
    }// </editor-fold>//GEN-END:initComponents
  
  
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
  
}
