/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.util;
import java.io.File;
import javax.swing.filechooser.FileFilter;
/**
 * JFileChooserに使用するファイルフィルターでABFの拡張子をもったものだけを通す。
 * アマテルの辞書ファイル(*.abf)を透過するフィルタ。
 * @author 大澤義鷹
 */
public class AmateruBookFileFilter extends FileFilter {

    @Override
    public boolean accept(File f) {
        if ( f.isDirectory() ) return true;
        String ext = FileFilterUtils.getExtension(f);
        if ( ext == null ) return false;
        return ext.equals("abf");
    }

    @Override
    public String getDescription() {
        return "Amateru Book File";
    }

}
