/*
 * FileFilterUtils.java
 *
 * Created on 2008/10/23, 12:43
 *
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.util;

import java.io.File;

/**
 * JFileChooser用のファイルフィルタを作るためのスーパークラス。
 * @author 大澤義孝
 */
public class FileFilterUtils {
    
    /**  FileFilterUtils オブジェクトを作成する */
    private FileFilterUtils() {
    }
    /**
     * ファイルの拡張子を小文字で返す。拡張子がついてない名前のときはnullを返す。
     */
    public static String getExtension( File f ) {
        String ext = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');
        if ( i > 0 &&  i < s.length() - 1 ) {
            ext = s.substring( i + 1 ).toLowerCase();
        }
        return ext;
    }
    
}
