/*
 * OccasionInputPanel.java
 *
 * Created on 2006/07/05, 1:04
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase;

import javax.swing.JPanel;
import to.tetramorph.starbase.lib.Natal;

/**
 * チャートタイプ別に複数のデータ入力パネルを作るのに使う。
 * DataInputDialogで、Natal.getChartType()が、"NATAL","EVENT","COMPOSIT"に応じて入
 * 力Panelを切り替えながら使えるようにするため、それら入力フォームの部品やメソッド
 * を定義した抽象クラス。
 */
abstract class AbstractNatalInputPanel extends JPanel {
  
  /**
   * Creates a new instance of OccasionInputPanel
   */
  public AbstractNatalInputPanel() {
    super();
  }
  /**
   * 各フィールドの値からOccasionを作成または上書きして返す。
   */
  public abstract Natal getNatal();
  /**
   * データ入力で必須項目がすべて満たされている場合はtrueを返す。
   */
  public abstract boolean isCompletion();
  /**
   * 各入力フィールドに初期値をセットする。
   */
  public abstract void setNatal(Natal occ);
  /**
   * 最初の入力フィールドにフォーカスを渡す。
   */
  public abstract void setFocus();
}
