/*
 * AppIcon.java
 * Created on 2011/08/08, 15:51:25.
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */
package to.tetramorph.starbase;

import java.awt.Image;
import java.util.ArrayList;
import java.util.List;
import to.tetramorph.util.IconLoader;

/**
 * アマテルのデスクトップアイコンを表す定数。
 * アイコンを変更するときは、このソースを変更すること。
 * @author ohsawa
 */
public class AppIcon {
    public static final Image DESKTOP_ICON;
    public static final Image TITLE_BAR_ICON;
    public static final List<Image> DESKTOP_ICONS;
    static {
        DESKTOP_ICON = IconLoader.getImage("/resources/niwatori32.png");
        TITLE_BAR_ICON = IconLoader.getImage("/resources/niwatori16.png");
        DESKTOP_ICONS = new ArrayList<Image>();
        int [] size = { 16,32,48,96,64 };
        for ( int sz : size ) {
            DESKTOP_ICONS.add(
                    IconLoader.getImage("/resources/niwatori"+ sz + ".png"));
        }
    }
}
