/*
 * HistoryEditPanel.java
 *
 * Created on 2006/10/03, 21:28
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;
import to.tetramorph.starbase.lib.Transit;

/**
 * ヒストリーを編集するパネル
 */
class HistoryEditPanel extends EventEditPanel {
  
  /**
   * オブジェクトを作成する。
   */
  protected HistoryEditPanel() {
    super("HISTORY");
    //中にずらずら書くとスコープの問題でわずらわしいのでメソッドは外に置く
    updateButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        updateButtonActionPerformed();
      }
    });
    registButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        registButtonActionPerformed();
      }
    });
  }
  protected List<Transit> getHistory() {
    return getEventList();
  }
  protected void setHistory(List<Transit> list) {
    setEventList(list);
  }
  protected void insertHistory(Transit event) {
    insert(event);
  }
  //更新ボタンの処理
  private void updateButtonActionPerformed() {                                             
    int row = table.getSelectedRow();
    if( row < 0 ) return;
    Transit event = eventList.get(row);
    if(EventInputDialog.showDialog(this,event,"ヒストリーデータを編集")) {
      super.updateButtonActionPerformed(event);
    }
  }
 //登録ボタンの処理
 private void registButtonActionPerformed() {
    Transit event = EventInputDialog.showDialog(this,"ヒストリーデータの登録");
    if(event != null) super.registButtonActionPerformed(event);
 }
}
