/*
 * ManualAction.java
 *
 * Created on 2008/11/21, 14:34
 *
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase;

import java.awt.Desktop;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.io.File;
import javax.swing.AbstractAction;
import javax.swing.JOptionPane;

/**
 * アマテルのPDFマニュアルをブラウザで開く。Mainの中で使用されている。
 * @author 大澤義孝
 */
public class ManualAction extends AbstractAction {

    private Frame owner;

    /**
     * ManualAction オブジェクトを作成。
     */
    public ManualAction( Frame owner ) {
        this.owner = owner;
    }


    @Override
    public void actionPerformed( ActionEvent evt ) {
        if ( Desktop.isDesktopSupported() ) {
            try {
                File doc = new File( System.getProperty("app.doc"),"man.pdf");
                if ( doc.exists() )
                    Desktop.getDesktop().browse( doc.toURI() );
                else
                    error("マニュアルが見つかりません。");
            } catch ( Exception e ) {
                error("ブラウザが使用できません。\n" + e.toString() );
            }
        } else
            error( "お使いのプラットホームでブラウザ機能がサポートされていません。");

    }

    private void error( String msg ) {
        JOptionPane.showMessageDialog( owner, msg, "ブラウザの起動に失敗",
                                                    JOptionPane.ERROR_MESSAGE );
    }
}
